#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3300one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 3300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3300one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one33004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                         
# -------------------------------------------------------------------------------------------------
# 3300
# -------------------------------------------------------------------------------------------------                                          
shot2one33004xi = {
                  1:'0x0y3299z',
                  2:'0x2184y2473z',
                  3:'0x99y3298z',
                  4:'1016x2820y1378z',
                  5:'1021x2674y1641z',
                  6:'1027x2107y2322z',
                  7:'1034x1593y2698z',
                  8:'104x81y3297z',
                  9:'1100x1515y2716z',
                  10:'1101x2365y2020z',
                  11:'1125x2030y2345z',
                  12:'113x2157y2494z',
                  13:'1153x2601y1670z',
                  14:'1157x2751y1407z',
                  15:'1161x1434y2735z',
                  16:'1214x2286y2046z',
                  17:'1216x1351y2753z',
                  18:'1217x1948y2368z',
                  19:'124x108y3295z',
                  20:'1266x1266y2771z',
                  21:'1280x2522y1698z',
                  22:'1293x2673y1437z',
                  23:'1304x1862y2391z',
                  24:'1310x1179y2789z',
                  25:'1321x2202y2072z',
                  26:'1348x1091y2807z',
                  27:'1380x1003y2824z',
                  28:'1385x1772y2414z',
                  29:'1402x2437y1726z',
                  30:'1423x2112y2097z',
                  31:'1424x2589y1467z',
                  32:'142x137y3294z',
                  33:'1460x1679y2436z',
                  34:'149x2952y1467z',
                  35:'1518x2346y1754z',
                  36:'1519x2018y2123z',
                  37:'1529x1583y2458z',
                  38:'1550x2499y1496z',
                  39:'157x168y3291z',
                  40:'1591x1484y2480z',
                  41:'15x394y3276z',
                  42:'1609x1919y2148z',
                  43:'1628x2249y1782z',
                  44:'1648x1382y2502z',
                  45:'1670x2402y1526z',
                  46:'1692x1817y2173z',
                  47:'1698x1279y2523z',
                  48:'169x201y3289z',
                  49:'1732x2147y1810z',
                  50:'1741x1174y2544z',
                  51:'1769x1710y2198z',
                  52:'1784x2299y1555z',
                  53:'178x236y3286z',
                  54:'1830x2039y1837z',
                  55:'1840x1601y2222z',
                  56:'184x272y3283z',
                  57:'185x348y3276z',
                  58:'186x310y3280z',
                  59:'186x399y3371z',
                  60:'1892x2190y1584z',
                  61:'189x2737y1833z',
                  62:'1903x1489y2246z',
                  63:'1921x1928y1865z',
                  64:'1960x1374y2270z',
                  65:'1993x2077y1613z',
                  66:'19x26y3299z',
                  67:'2006x1812y1892z',
                  68:'2083x1692y1919z',
                  69:'2087x1958y1641z',
                  70:'2153x1569y1945z',
                  71:'2174x1836y1670z',
                  72:'218x2491y2152z',
                  73:'223x2123y2516z',
                  74:'2253x1709y1698z',
                  75:'257x3052y1226z',
                  76:'302x2925y1496z',
                  77:'32x360y3280z',
                  78:'330x2083y2537z',
                  79:'330x2705y1860z',
                  80:'345x2455y2177z',
                  81:'35x55y3299z',
                  82:'3x33y3299z',
                  83:'3x66y3299z',
                  84:'414x3022y1257z',
                  85:'433x2038y2558z',
                  86:'453x2890y1525z',
                  87:'468x2412y2202z',
                  88:'468x2665y1887z',
                  89:'46x2761y1805z',
                  90:'46x326y3283z',
                  91:'48x86y3298z',
                  92:'532x1988y2579z',
                  93:'570x2984y1287z',
                  94:'57x290y3286z',
                  95:'589x2363y2226z',
                  96:'58x118y3297z',
                  97:'600x2848y1555z',
                  98:'603x2619y1914z',
                  99:'628x1933y2599z',
                  100:'64x151y3295z',
                  101:'64x255y3289z',
                  102:'68x185y3294z',
                  103:'68x220y3291z',
                  104:'705x2307y2250z',
                  105:'719x1873y2619z',
                  106:'722x2937y1317z',
                  107:'734x2565y1941z',
                  108:'744x2797y1584z',
                  109:'805x1809y2639z',
                  110:'817x2246y2274z',
                  111:'861x2505y1967z',
                  112:'871x2883y1347z',
                  113:'885x2739y1612z',
                  114:'886x1740y2659z',
                  115:'88x2521y2127z',
                  116:'925x2179y2298z',
                  117:'963x1668y2678z',
                  118:'97x3074y1195z',
                  119:'983x2438y1994z'}
#"
#"/>
if ack2debug is True:
    keys2xyz = shot2one33004xi.keys()
    layer2fire = 3300
    
    count2xyz = 0
    
    sum2deviation = 0
    max2deviation = 0
    sum2radius = 0
    max2radius = 0
        
    for key2xyz in keys2xyz:
        i2x = str.find(shot2one33004xi[key2xyz],"x")
        i2y = str.find(shot2one33004xi[key2xyz],"y") 
        i2z = str.find(shot2one33004xi[key2xyz],"z")
                        
        x2coordinate = int(shot2one33004xi[key2xyz] [0:i2x])
        y2coordinate = int(shot2one33004xi[key2xyz] [i2x+1:i2y])
        z2coordinate = int(shot2one33004xi[key2xyz] [i2y+1:i2z])    
        count2xyz = count2xyz + 1
        
        radius2coordinate = (x2coordinate**2 + y2coordinate**2 + z2coordinate**2) ** (1/2)
        if radius2coordinate > max2radius:
            max2radius = radius2coordinate
        sum2radius = sum2radius + radius2coordinate

        deviation2distance = (radius2coordinate - layer2fire)**2
        sum2deviation = sum2deviation + deviation2distance
  
        if deviation2distance**(1/2) > max2deviation:
            max2deviation = deviation2distance**(1/2)
    
    deviation2expected = count2xyz - 100
                
    average2radius = sum2radius / count2xyz    

    degree2freedom = count2xyz - 1
    
    std2deviation = (sum2deviation/degree2freedom) **(1/2) 
    
    std2varians = std2deviation**2
     
    
    print('=' *33)                 
    print('STATISTICS')
    print('=' *33)     
    print("LAYER2FIRE: " , layer2fire)
    print("COUNT2XYZ: " , count2xyz)
    print("DEVIATION2EXPECTED: " , deviation2expected)   
    print("MAX2DEVIATION: " , int(max2deviation))
    print("AVERAGE2RADIUS: " , int(average2radius)) 
    print("MAX2RADIUS: " , int(max2radius))   
    print("STD2DEVIATION: " , int(std2deviation))    
    print("STD2VARIANS: " , int(std2varians))    
    print("DEGREE2FREEDOM: " , int(degree2freedom))
              
    print('=' *33)    
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3300one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3300one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3300ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3300ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3300ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3300ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3300ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE33004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one33004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3300ONE4XI - SUCCEEDED TO PUT SHOT2ONE33004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE33004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3300ONE4XI *** FAILED TO PUT SHOT2ONE33004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3300ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one33004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one33004xi</nack2put4xi>" 
             
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3300ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one33004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE3300ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3300ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3300one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
